program define errequal_results, rclass
  * Michael Tomz and Robert Van Houweling, "Candidate Positioning and Voter Choice,"
  * American Political Science Review 102, no. 3 (August 2008): 303-318.
  *
  * Purpose: Part of Appendix B
  *    Transforms maximum likelihood point estimates into quantities of interest
  *    The quantities of interest are rates of prox, disc, dir, and error
  * Version: February 21, 2010
  * Syntax:  Stata 9.2   
  version 9.2    
  tempname denom pdir pdisc pprox error
  scalar `denom' = 1 + exp(_b[pdirt:_cons]) + exp(_b[pdisct:_cons])
  scalar `pdir' = exp(_b[pdirt:_cons])/`denom'
  scalar `pdisc' = exp(_b[pdisct:_cons])/`denom'
  scalar `pprox' = 1/`denom' 
  scalar `error' = 1/(1+exp(-_b[et:_cons]))
  di in y _n "pprox: " %6.3f `pprox'
  di in y "pdisc: " %6.3f `pdisc'
  di in y "pdir : " %6.3f `pdir'
  di in y "error: " %6.3f `error' _n
  return scalar pdir = round(`pdir',.001)
  return scalar pdisc = round(`pdisc',.001)
  return scalar pprox = round(`pprox',.001)
  return scalar error = round(`error',.001)
end
