program define est_rates, rclass
  * Michael Tomz and Robert Van Houweling, "Candidate Positioning and Voter Choice,"
  * American Political Science Review 102, no. 3 (August 2008): 303-318.
  *
  * Purpose: Estimate rates of prox, dir, disc, and common error rate
  * Version: February 21, 2010
  * Syntax:  Stata 9.2
  version 9.2
  syntax [if/] [in]
  if "`if'" ~= "" {
	 local if & (`if')
  }
  tempname pi1 pi2 pi4 pidir pidisc
  su pickc2 if scennum==1 `if' `in', meanonly
  scalar `pi1' = `r(mean)'
  su pickc2 if scennum==2 `if' `in', meanonly
  scalar `pi2' = `r(mean)'
  su pickc2 if scennum==4 `if' `in', meanonly
  scalar `pi4' = `r(mean)'
  scalar `pidir' = (`pi1' - `pi2')/(1 - 2*`pi2')
  scalar `pidisc' = (`pi4' - `pi1')/(1 - 2*`pi2')
  return scalar piprox = 1 - `pidir' - `pidisc'
  return scalar pidir = `pidir'
  return scalar pidisc = `pidisc'
  return scalar error = `pi2'
end
