program define est_rates_bygroup, rclass
  * Michael Tomz and Robert Van Houweling, "Candidate Positioning and Voter Choice,"
  * American Political Science Review 102, no. 3 (August 2008): 303-318.
  *
  * Purpose: Estimates rates of prox, disc, dir, and error rate for 2 subgroups
  * Version: February 21, 2010
  * Syntax:  Stata 9.2
  version 9.2
  syntax [if/] [in], group1(str) group2(str)
  if "`if'" ~= "" {
	 local if & (`if')
  }
  tempname pi1 pi2 pi4 pidir pidisc
  forvalues i = 2(-1)1 {
	 su pickc2 if scennum==1 & (`group`i'') `if' `in', meanonly
	 scalar `pi1' = `r(mean)'
	 su pickc2 if scennum==2 & (`group`i'') `if' `in', meanonly
	 scalar `pi2' = `r(mean)'
	 su pickc2 if scennum==4 & (`group`i'') `if' `in', meanonly
	 scalar `pi4' = `r(mean)'
	 scalar `pidir' = (`pi1' - `pi2')/(1 - 2*`pi2')
	 scalar `pidisc' = (`pi4' - `pi1')/(1 - 2*`pi2')
	 return scalar error`i' = `pi2'
	 return scalar pidir`i' = `pidir'
	 return scalar pidisc`i' = `pidisc'
	 return scalar piprox`i' = 1 - `pidir' - `pidisc'
  }
end
