*! 2.1.5 MRT 7 August 2008
* 2.1.4 MRT 7 July 2007
* 2.1.3 NJC 19 March 2007
* 2.1.2 NJC 4 December 2004 
* 2.1.1 NJC 17 August 2004 
* 2.1.0 NJC 14 August 2004 
* 2.0.1 NJC 5 August 2004 
* 2.0.0 NJC 27 January 2004 
* 1.2.3 NJC 28 June 2000 
* 1.2.2 NJC 24 November 1999
* 1.2.1 NJC 28 March 1999
* 1.1.0 NJC 6 May 1998
* program triplotmt, sortpreserve  
program triplotmt  /* MRT removed sortpreserve */
	version 8.0
	syntax varlist(min=3 max=3 numeric) [if] [in]        ///
	[, max(numlist max=1 >0)  SEParate(varname)          ///
	centre(numlist min=3 max=3 >0)                       ///
	center(numlist min=3 max=3 >0)                       ///
	LAbel(str) grid(str asis)                            ///
	VERTices(real 1) frame(str asis) Y Y2(str)           ///  
	ltext(str) rtext(str) btext(str)                     ///
	bltext(str) brtext(str) ttext(str)                   /// 
	text(str asis) by(str) moregraphs(str asis) * ]   /*  MRT added the moregraphs option */
	
	// -by()- not supported 
	if "`by'" != "" { 
		di as err "by() not supported" 
		exit 198 
	} 	

	// # to use 
	marksample touse
	qui count if `touse'
	local nuse = r(N)
	if `nuse' == 0 error 2000
	
	// default maximum; check 0 <= values <= maximum 
	if "`max'" == "" local max 1 

	tokenize `varlist'
	args a b c 
	foreach v of local varlist { 
		capture assert `v' >= 0 & `v' <= `max' if `touse'
		if _rc {
			di as err "`v' has values outside [0, `max']"
			exit 198
		}
	}

	// labels 
	if "`label'" != "nolabels" { 
		if "`label'" == "" {
			if `max' == 1000 local label "0 200 400 600 800 1000"
			else if `max' == 100 local label "0 20 40 60 80 100" 
			else local label "0 .2 .4 .6 .8 1"
		}	
		else { 
			local abb = substr("sixths",1,length("`labels'")) 
			if lower("`label'") == "`abb'" { 
				local label "0 1/6 1/3 1/2 2/3 5/6 1" 
				local sixths "sixths"
			}
			else { 	
				numlist "`label'", miss
				local label "`r(numlist)'" 
			} 
		} 	
	}	
	else local label 

	local n : word count `label' 
	local n = max(3 * `n', 13) 
	qui if `n' > _N { 
		preserve 
		set obs `n' 
	} 	
	
	// graph geometry constants 
	local htfact = sqrt(3)/2                    /* sin _pi/3 = 60 deg */
	local xL 0                                /* triangle coordinates */
	local xR 1 
	local xT = (`xL' + `xR') / 2
	local width = `xR' - `xL'
	local height = `width' * `htfact'
	local yB 0
	local yT = `yB' + `height'
	local yM = `yB' + `height' / 2            /* position of var text */

	tempvar left right bot yvar xvar                  ///
	        frame_y frame_x label_y label_x y_y y_x   ///
	        text_txt text_y text_x text_pos           ///
	        l_label_txt l_label_y l_label_x           ///
		r_label_txt r_label_y r_label_x           /// 
		b_label_txt b_label_y b_label_x  

	quietly {
		// scale if necessary 
		gen `left' = `a'
		gen `right' = `b'
		gen `bot' = `c' 
	    
		if "`center'`centre'" != "" {
			tempvar left2 right2 bot2
			tokenize "`center'`centre'" 
			args A B C 
			gen `left2' = ///
	(`left' / `A') / ((`left' / `A') + (`right' / `B') + (`bot' / `C'))
			gen `right2' = /// 
	(`right' / `B') / ((`left' / `A') + (`right' / `B') + (`bot' / `C'))
			gen `bot2' = /// 
	(`bot' / `C') / ((`left' / `A') + (`right' / `B') + (`bot' / `C'))
			local left "`left2'"
			local right "`right2'" 
			local bot "`bot2'" 
			local A = `A' / `max'
			local B = `B' / `max'
			local C = `C' / `max'
		} 
		else if `max' != 1 {
			replace `left' = `left' / `max' 
			replace `right' = `right' / `max' 
			replace `bot' = `bot' / `max' 
	        }

		// text on sides and at vertices 
		gen `text_txt' = ""
		
		if `"`ltext'"' == "" {
			local ltext : variable label `a'
			if `"`ltext'"' == "" local ltext "`a'"
		}	
		replace `text_txt' = `"`ltext'"' in 1 
		
	        if `"`rtext'"' == "" {
			local rtext : variable label `b'
			if `"`rtext'"' == "" local rtext "`b'" 
		} 	
	        replace `text_txt' = `"`rtext'"' in 2 
		
	    	if `"`btext'"' == "" {
			local btext : variable label `c'
			if `"`btext'"' == "" local btext "`c'" 
		} 	
		replace `text_txt' = `"`btext'"' in 3 
	        
		if `"`bltext'"' != "" replace `text_txt' = `"`bltext'"' in 4 
		if `"`ttext'"' != ""  replace `text_txt' = `"`ttext'"'  in 5 
		if `"`brtext'"' != "" replace `text_txt' = `"`brtext'"' in 6 
	
		gen `text_y' = `yM' + 1/24 in 1/2  
		replace `text_y' = -1/24 in 3/4 
		replace `text_y' = `yT' in 5
*		replace `text_y' = 0  in 6        /* MRT replaced this line */
		replace `text_y' = -1/24  in 6    /* with this line */
		
		gen `text_x' = `xL' + 5 * `width' / 24  in 1  
		replace `text_x' = `xT' + 7 * `width' / 24 in 2 
		replace `text_x' = `xT' in 3 
		replace `text_x' = `xL' in 4 
		replace `text_x' = `xT' in 5 
		replace `text_x' = `xR' in 6 

		gen `text_pos' = 9 in 1 
		replace `text_pos' = 3 in 2 
		replace `text_pos' = 6 in 3 
		replace `text_pos' = 9 in 4 
		replace `text_pos' = 12 in 5
		replace `text_pos' = 3 in 6 
		
		// triangular frame
		if `vertices' == 1 {
			gen `frame_y' = `yB' in 1 
			replace `frame_y' = `yT' in 2
			replace `frame_y' = `yB' in 3/4  
			
			gen `frame_x' = `xL' in 1 
			replace `frame_x' = `xT' in 2
			replace `frame_x' = `xR' in 3 
			replace `frame_x' = `xL' in 4 
		}
		else {
			local v = `vertices' / 2
			local yV = `yB' + `v' * (`yT' - `yB')
			local yV2 = `yT' - `v' * (`yT' - `yB')
			local xV = `xL' + `v' * `width' / 2
			local xV2 = `xT' - `v' * `width' / 2
			local xV3 = `xT' + `v' * `width' / 2
			local xV4 = `xR' - `v' * `width' / 2
			local xV5 = `xR' - `v' * `width' 
			local xV6 = `xL' + `v' * `width' 
			
			gen `frame_y' = `yB' in 1 
			replace `frame_y' = `yV' in 2
			// 3 is missing 
			replace `frame_y' = `yV2' in 4  
			replace `frame_y' = `yT' in 5  
			replace `frame_y' = `yV2' in 6 
			// 7 is missing 
			replace `frame_y' = `yV' in 8  
			replace `frame_y' = `yB' in 9/10 
			// 11 is missing 
			replace `frame_y' = `yB' in 12/13 
			
			gen `frame_x' = `xL' in 1 
			replace `frame_x' = `xV' in 2
			// 3 is missing 
			replace `frame_x' = `xV2' in 4  
			replace `frame_x' = `xT' in 5  
			replace `frame_x' = `xV3' in 6 
			// 7 is missing 
			replace `frame_x' = `xV4' in 8  
			replace `frame_x' = `xR' in 9 
			replace `frame_x' = `xV5' in 10 
			// 11 is missing 
			replace `frame_x' = `xV6' in 12
			replace `frame_x' = `xL' in 13
		}

		// y ? 
		gen `y_y' = . 
		gen `y_x' = . 
		
		//   1 on bottom side (y = `yB') 
		//   2 in middle 
		//   3 on left side
		//   4 missing (no connect) 
		//   5 on right side
		//   6 = 2 
		
		if "`y'" == "y" | "`y2'" != "" {
			if "`centre'`centre'" == "" { 
				local yY2 = `yB' + (`yT' + `yB') / 3
				local yY3 = (`yT' + `yB') / 2
				local yY5 = (`yT' + `yB') / 2
				local xY1 = `xT'
				local xY2 = `xT'
				local xY3 = (`xL' + `xT') / 2
				local xY5 = (`xR' + `xT') / 2
			}
			else {
				local yAA = (1 / `A') / ((1 / `A') + (1 / `B') + (1 / `C'))
				local yBB = (1 / `B') / ((1 / `A') + (1 / `B') + (1 / `C'))
				local yY2 = `yB' + `height' * `yAA' 
				local yY3 = ///  
		`yB' + `height' * (1 / `A') / ((1 / `A') + (1 / `C'))
				local yY5 = ///  
		`yT' - `height' * (1 / `B') / ((1 / `A') + (1 / `B'))  
				local xY1 = ///
		`xR' - `width' * (1 / `C') / ((1 / `B') + (1 / `C'))  
				local xY2 = `xL' + `width' * (`yBB' + (`yAA' / 2) 
				local xY3 = ///
		`xL' + (`width' / 2) * (1 / `A') / ((1 / `A') + (1 / `C'))  
				local xY5 = ///
		`xT' + (`width' / 2) * (1 / `B') / ((1 / `A') + (1 / `B'))  
			} 

			replace `y_y' = `yB' in 1
			replace `y_y' = `yY2' in 2 
			replace `y_y' = `yY3' in 3 
			replace `y_y' = `yY5' in 5 
			replace `y_y' = `yY2' in 6 
			
			replace `y_x' = `xY1' in 1 
			replace `y_x' = `xY2' in 2 
			replace `y_x' = `xY3' in 3
			replace `y_x' = `xY5' in 5 
			replace `y_x' = `xY2' in 6
		}

		// labels 
		// these variables are all born missing; 
		// we leave missings in gaps to stop connection 
		gen `l_label_txt' = ""
		gen `l_label_y' = . 
		gen `l_label_x' = . 
		gen `r_label_txt' = ""
		gen `r_label_y' = . 
		gen `r_label_x' = . 
		gen `b_label_txt' = ""
		gen `b_label_y' = . 
		gen `b_label_x' = . 

		local i = 1 
		foreach l of local label { 
			replace `l_label_txt' = `"`l'"' in `i' 
			replace `r_label_txt' = `"`l'"' in `i' 
			replace `b_label_txt' = `"`l'"' in `i' 

			if "`sixths'" != "" local l = `l'
			else local l = `l' / `max' 
			
			if "`centre'`center'" == "" { 
				replace `l_label_y' = `yB' + `height' * `l' in `i' 
				replace `l_label_x' = `xL' + (`width' / 2) * `l' in `i' 
				replace `r_label_x' = `xT' + (`width' / 2) * `l' in `i' 
				replace `r_label_y' = `yT' - `height' * `l' in `i' 
				replace `b_label_x' = `xR' - `width' * `l' in `i' 
				replace `b_label_y' = `yB' in `i' 
			
				local ++i 
				if `l' > 0 & `l' < 1 { 
					replace `l_label_x' = `xT' + (`width' / 2) * (1 - `l') in `i' 
					replace `l_label_y' = `yB' + `height' * `l' in `i'
					replace `r_label_x' = `xL' + `width' * `l' in `i' 
					replace `r_label_y' = `yB' in `i' 
					replace `b_label_x' = `xL' + (`width' / 2) * (1 - `l') in `i' 
					replace `b_label_y' = `yT' - `height' * `l' in `i' 
				} 	
			} 
			else { 
				local ll = (`l' / `A') / ((`l' / `A') + (1 - `l') / `C') 
				local lr = (`l' / `B') / ((`l' / `B') + (1 - `l') / `A') 
				local lb = (`l' / `C') / ((`l' / `C') + (1 - `l') / `B') 
				local lL = ((1 - `l') / `B') / ((`l' / `A') + (1 - `l') / `B') 
				local lR = ((1 - `l') / `C') / ((`l' / `B') + (1 - `l') / `C') 
				local lB = ((1 - `l') / `A') / ((`l' / `C') + (1 - `l') / `A') 
	
				replace `l_label_y' = `yB' + `height' * `ll' in `i' 
				replace `l_label_x' = `xL' + (`width' / 2) * `ll' in `i' 
				replace `r_label_x' = `xT' + (`width' / 2) * `lr' in `i' 
				replace `r_label_y' = `yT' - `height' * `lr' in `i' 
				replace `b_label_x' = `xR' - `width' * `lb' in `i' 
				replace `b_label_y' = `yB' in `i' 
			
				local ++i 
				if `l' > 0 & `l' < 1 { 
					replace `l_label_x' = `xT' + (`width' / 2) * `lL' in `i' 
					replace `l_label_y' = `yB' + `height' * (1 - `lL') in `i'
					replace `r_label_x' = `xL' + `width' * (1 - `lR') in `i' 
					replace `r_label_y' = `yB' in `i' 
					replace `b_label_x' = `xL' + (`width' / 2) * `lB' in `i' 
					replace `b_label_y' = `yB' + `height' * `lB' in `i' 
				} 	
			} 
	
			local i = `i' + 2 
		}	

		// x, y coordinates to show on scatter 
		gen `yvar' = `yB' + `height' * `left' if `touse' 
		gen `xvar' = `xL' + `width' * (`right' + `left' / 2) if `touse' 

		if "`separate'" != "" { 
			separate `yvar', by(`separate') shortlabel 
			local yvar "`r(varlist)'" 
			local nvars : word count `r(varlist)' 
			foreach v of local yvar { 
				local label : variable label `v' 
				local label = substr(`"`label'"', index(`"`label'"',"==") + 2, .) 
				label var `v' `"`label'"' 
			} 	
		} 
		else local nvars 1 

		// legend for 2 or more variables 
		local start = 7 
		if `nvars' > 1 { 
			numlist "`start'(1)`=`start' + `nvars''"
			local legend "legend(order(`r(numlist)'))" 
		}	 
		else local legend "legend(off)" 
	}	
	// end of quietly

	// graph 


	twoway 	connect `l_label_y' `l_label_x', ms(none) mlabp(10)       ///   /* this puts the numbers on the left */
		mlabel(`l_label_txt') mlabc(black) clc(black) cmiss(n)    ///
		clp(dot) `grid'                                           ///  
	|| connect `r_label_y' `r_label_x', ms(none) mlabp(2)             ///   /* this puts the numers on the right */
		mlabel(`r_label_txt') mlabc(black) clc(black) cmiss(n)    ///
		clp(dot) `grid'                                           ///
	|| connect `b_label_y' `b_label_x', ms(none) mlabp(6)             ///
		mlabel(`b_label_txt') mlabc(black) clc(black) cmiss(n)    ///   /* this puts the numbers on the bottom */
		clp(dot) `grid'                                           ///
	|| line `frame_y' `frame_x', clc(black) cmiss(n) clp(solid)       ///
		`frame'                                                   ///
	|| line `y_y' `y_x', clc(black) clp(shortdash) cmiss(n) `y2'      ///  
	|| scatter `text_y' `text_x', ms(none) mla(`text_txt')            ///
		mlabc(black) mlabvpos(`text_pos') `text'                  ///  
	|| scatter `yvar' `xvar'                                          ///
		, ms(Oh) plotregion(style(none)) yscale(off) xscale(off)  ///
		yscale(ra(.,0.9)) xscale(ra(-0.1,1.1)) yla(, nogrid)      ///
		`legend' `options'         ///  /* MRT added the moregraphs option here */
                `moregraphs'                        

end
