# ternary plot of the estimates
#------------------------------
reset
set size ratio 0.866
set bmargin 2
set tmargin 2
set lmargin 0
set rmargin 0
set yrange [0:0.866]
set xrange [0:1]
unset border
unset xtics
unset ytics

set label 'Directional' at 0, -0.03 right
set label 'Disc. Prox.' at 1, -0.03 left
set label 'Proximity' at 0.5, 0.91 center


# boundary
set arrow from 0,0 to 1,0 nohead lt -1 lw 3
set arrow from 0,0 to 0.5,0.886 nohead lt -1 lw 3
set arrow from 0.5,0.886 to 1,0 nohead lt -1 lw 3

# tics
# for the dir-prox axis, the displacement is -0.00866, 0.005
set arrow from 0.0975, 0.1732 to 0.08884, 0.1782 nohead lw 2
set arrow from 0.195, 0.3464 to 0.18634, 0.3514 nohead lw 2
set arrow from 0.2925, 0.5196 to 0.28384, 0.5246 nohead lw 2
set arrow from 0.39, 0.6928 to 0.38134, 0.6978 nohead lw 2

set arrow from 0.9025, 0.1732 to 0.91116, 0.1782 nohead lw 2
set arrow from 0.805, 0.3464 to 0.81366, 0.3514 nohead lw 2
set arrow from 0.7075, 0.5196 to 0.71616, 0.5246 nohead lw 2
set arrow from 0.61, 0.6928 to 0.61866, 0.6978 nohead lw 2
        
set arrow from 0.2, 0 to 0.2,-0.01 nohead lw 2
set arrow from 0.4, 0 to 0.4,-0.01 nohead lw 2
set arrow from 0.6, 0 to 0.6,-0.01 nohead lw 2
set arrow from 0.8, 0 to 0.8,-0.01 nohead lw 2

# labels
set label "0.2" at 0.075,0.1832 right
set label "0.4" at 0.175,0.3564 right
set label "0.6" at 0.275,0.5296 right
set label "0.8" at 0.375,0.7028 right

set label "0.8" at 0.925,0.1832 left
set label "0.6" at 0.825,0.3564 left
set label "0.4" at 0.725,0.5296 left
set label "0.2" at 0.625,0.7028 left

set label "0.8" at 0.2,-0.04 center
set label "0.6" at 0.4,-0.04 center
set label "0.4" at 0.6,-0.04 center
set label "0.2" at 0.8,-0.04 center

# lines and labels locating tvh estimate
set arrow from 0.28,0.50 to 0.565,0.5 nohead lt 0 lw 3
set arrow from 0.565,0.5 to 0.64,0.64 nohead lt 0 lw 3
set arrow from 0.565,0.5 to 0.853,0 nohead lt 0 lw 3
set label '14.7%' at 0.85,-0.05
set label '27.6%' at 0.68,0.64
set label '57.7%' at 0.1,0.48


set terminal pdf fsize 10 dashed dl 1

set output "EstPlot.pdf"
plot 'summaryEst.csv' u ($2+$1/2):(sqrt(3)*$1/2) ps 2 lc 3 not, \
'ci95.csv' u 1:2 w l lc 1 lt 1 lw 2 not, \
'ci75.csv' u 1:2 w l lc 1 lt 2 lw 2 not
set output

#plot 'voteData5-bte.csv' u ($6+$5/2):(sqrt(3)*$5/2) ps 2 lc 3 not, \
#'ci95.csv' u 1:2 w l lc 1 lt 1 lw 2 not, \
#'ci75.csv' u 1:2 w l lc 1 lt 2 lw 2 not
